<?php

/**
 * @file
 * Contains \Drupal\test_reference_access\Controller\TestReferenceAccessController.
 */

namespace Drupal\test_reference_access\Controller;

class TestReferenceAccessController {
  public function testAccessPage() {
    $query = db_select('node_field_data', 'np')
      ->addTag('node_access');
    $query->leftJoin('node__field_related_article', 'npa', "np.nid = npa.entity_id AND npa.deleted = '0' AND npa.langcode = np.langcode");
    $query->leftJoin('node_field_data', 'nra', "npa.field_related_article_target_id = nra.nid");
    $query->fields('np', array('nid', 'title'))
      ->fields('nra', array('nid', 'title'))
      ->where("np.type = 'page'")
      ->orderBy('np.title');
    $result = $query->execute();
    $output = '<pre>' . print_r($query->__toString(), TRUE) . '</pre>';
    $rows = array();
    foreach ($result as $record) {
      $row = array();
      $row[] = $record->title;
      if ($record->nra_nid) {
        $row[] = $record->nra_title;
      }
      else {
        $row[] = '';
      }
      //$output .= $record->title . '<br />';
      $rows[] = $row;
    }
    $output .= '<pre>' . print_r($rows, TRUE) . '</pre>';
    return array(
      '#theme' => 'table',
      '#rows' => $rows,
      '#header' => array('Page', 'Article'),
    );
  }
}
